package com.unipi.talepis.protal2023_4;

import androidx.annotation.NonNull;
import androidx.appcompat.app.AlertDialog;
import androidx.appcompat.app.AppCompatActivity;

import android.os.Bundle;
import android.view.View;
import android.widget.EditText;
import android.widget.TextView;

import com.google.android.gms.tasks.OnCompleteListener;
import com.google.android.gms.tasks.Task;
import com.google.firebase.auth.AuthResult;
import com.google.firebase.auth.FirebaseAuth;
import com.google.firebase.database.DataSnapshot;
import com.google.firebase.database.DatabaseError;
import com.google.firebase.database.DatabaseReference;
import com.google.firebase.database.FirebaseDatabase;
import com.google.firebase.database.ValueEventListener;

public class MainActivity extends AppCompatActivity {
    EditText emailText,passwordText,messageInput;
    TextView messageOutput;
    FirebaseAuth auth;
    FirebaseDatabase database;
    DatabaseReference reference;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        emailText = findViewById(R.id.editTextTextEmailAddress);
        passwordText = findViewById(R.id.editTextTextPassword);
        auth = FirebaseAuth.getInstance();
        messageInput = findViewById(R.id.editTextText2);
        messageOutput = findViewById(R.id.textView);
        database = FirebaseDatabase.getInstance();
        reference = database.getReference("message");
        reference.addValueEventListener(new ValueEventListener() {
            @Override
            public void onDataChange(@NonNull DataSnapshot snapshot) {
                messageOutput.setText(messageOutput.getText().toString()+"\n"+snapshot.getValue().toString());
            }

            @Override
            public void onCancelled(@NonNull DatabaseError error) {

            }
        });
    }
    public void go1(View view){
        auth.createUserWithEmailAndPassword(emailText.getText().toString(),passwordText.getText().toString())
                .addOnCompleteListener(task -> {
                    if (task.isSuccessful()){
                        showMessage("Success","User created successfully!");
                    } else {
                        showMessage("Error",task.getException().getLocalizedMessage());
                    }
                });
    }
    public void go2(View view){
        auth.signInWithEmailAndPassword(emailText.getText().toString(),passwordText.getText().toString())
                .addOnCompleteListener(task -> {
                    if (task.isSuccessful()){
                        showMessage("Success","User signed in successfully!");
                        showMessage("User id",auth.getUid());
                    } else {
                        showMessage("Error",task.getException().getLocalizedMessage());
                    }
                });
        //auth.signOut();
    }
    public void go3(View view){
        if(!messageInput.getText().toString().isEmpty()){
            //reference.child(auth.getUid()).setValue(messageInput.getText().toString());
            reference.setValue(messageInput.getText().toString());

        }
    }
    void showMessage(String title, String message){
        new AlertDialog.Builder(this).setTitle(title).setMessage(message).setCancelable(true).show();
    }
}